Merge branch 'mpls-next'
[deliverable/linux.git] / scripts / kconfig / Makefile
CommitLineData
1da177e4
LT
1# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
03fa25da 5PHONY += oldconfig xconfig gconfig menuconfig config silentoldconfig update-po-config \
281c9dad 6 localmodconfig localyesconfig
1da177e4 7
61bee204
AV
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
838a2e55 11Kconfig := Kconfig
61bee204 12endif
e703f75d 13
c2838e6e
YM
14# We need this, in case the user has it in its environment
15unexport CONFIG_
16
1da177e4 17xconfig: $(obj)/qconf
e703f75d 18 $< $(Kconfig)
1da177e4
LT
19
20gconfig: $(obj)/gconf
e703f75d 21 $< $(Kconfig)
1da177e4
LT
22
23menuconfig: $(obj)/mconf
e703f75d 24 $< $(Kconfig)
1da177e4
LT
25
26config: $(obj)/conf
4062f1a4 27 $< --oldaskconfig $(Kconfig)
1da177e4 28
692d97c3 29nconfig: $(obj)/nconf
30 $< $(Kconfig)
31
1da177e4 32oldconfig: $(obj)/conf
4062f1a4 33 $< --$@ $(Kconfig)
1da177e4
LT
34
35silentoldconfig: $(obj)/conf
9815594a 36 $(Q)mkdir -p include/config include/generated
4062f1a4 37 $< --$@ $(Kconfig)
1da177e4 38
50bce3e8 39localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
9815594a 40 $(Q)mkdir -p include/config include/generated
22d550ae 41 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
7a996d3a 42 $(Q)if [ -f .config ]; then \
4062f1a4
SR
43 cmp -s .tmp.config .config || \
44 (mv -f .config .config.old.1; \
45 mv -f .tmp.config .config; \
46 $(obj)/conf --silentoldconfig $(Kconfig); \
47 mv -f .config.old.1 .config.old) \
48 else \
49 mv -f .tmp.config .config; \
50 $(obj)/conf --silentoldconfig $(Kconfig); \
a7c02602 51 fi
03fa25da
SR
52 $(Q)rm -f .tmp.config
53
1020026f 54# Create new linux.pot file
b70e325c 55# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
46d26319 56update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
e2aef4d3 57 $(Q)echo " GEN config.pot"
a24a1b8e
PF
58 $(Q)xgettext --default-domain=linux \
59 --add-comments --keyword=_ --keyword=N_ \
60 --from-code=UTF-8 \
61 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
62 --directory=$(srctree) --directory=$(objtree) \
b70e325c
SR
63 --output $(obj)/config.pot
64 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
fa0ad657
PB
65 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
66 $(srctree)/arch/*/um/Kconfig`; \
1020026f 67 do \
e2aef4d3 68 echo " GEN $$i"; \
4217516e 69 $(obj)/kxgettext $$i \
1020026f
EG
70 >> $(obj)/config.pot; \
71 done )
e2aef4d3 72 $(Q)echo " GEN linux.pot"
1020026f 73 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
b70e325c 74 --output $(obj)/linux.pot
b70e325c 75 $(Q)rm -f $(obj)/config.pot
3b9fa093 76
0748cb3e 77PHONY += allnoconfig allyesconfig allmodconfig alldefconfig randconfig
1da177e4 78
0748cb3e 79allnoconfig allyesconfig allmodconfig alldefconfig randconfig: $(obj)/conf
4062f1a4 80 $< --$@ $(Kconfig)
1da177e4 81
fb16d891 82PHONY += listnewconfig olddefconfig oldnoconfig savedefconfig defconfig
1da177e4 83
fb16d891 84listnewconfig olddefconfig: $(obj)/conf
4062f1a4 85 $< --$@ $(Kconfig)
1da177e4 86
fb16d891
AL
87# oldnoconfig is an alias of olddefconfig, because people already are dependent
88# on its behavior(sets new symbols to their default value but not 'n') with the
89# counter-intuitive name.
90oldnoconfig: $(obj)/conf
91 $< --olddefconfig $(Kconfig)
92
7cf3d73b
SR
93savedefconfig: $(obj)/conf
94 $< --$@=defconfig $(Kconfig)
95
1da177e4
LT
96defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
4062f1a4 98 $< --defconfig $(Kconfig)
1da177e4 99else
2266cfd5 100 @echo "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
4062f1a4 101 $(Q)$< --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
1da177e4
LT
102endif
103
104%_defconfig: $(obj)/conf
4062f1a4 105 $(Q)$< --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
1da177e4 106
3aaefce1
JT
107configfiles=$(wildcard $(srctree)/kernel/configs/$(1).config $(srctree)/arch/$(SRCARCH)/configs/$(1).config)
108
109define mergeconfig
110$(if $(wildcard $(objtree)/.config),, $(error You need an existing .config for this target))
111$(if $(call configfiles,$(1)),, $(error No configuration exists for this target on this architecture))
112$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m -O $(objtree) $(objtree)/.config $(call configfiles,$(1))
113$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
114endef
115
116PHONY += kvmconfig
117kvmconfig:
118 $(call mergeconfig,kvm_guest)
119
0da1d4a0
JT
120PHONY += tinyconfig
121tinyconfig: allnoconfig
122 $(call mergeconfig,tiny)
123
1da177e4
LT
124# Help text used by make help
125help:
126 @echo ' config - Update current config utilising a line-oriented program'
692d97c3 127 @echo ' nconfig - Update current config utilising a ncurses menu based program'
1da177e4
LT
128 @echo ' menuconfig - Update current config utilising a menu based program'
129 @echo ' xconfig - Update current config utilising a QT based front-end'
130 @echo ' gconfig - Update current config utilising a GTK based front-end'
131 @echo ' oldconfig - Update current config utilising a provided .config as base'
03fa25da 132 @echo ' localmodconfig - Update current config disabling modules not loaded'
281c9dad 133 @echo ' localyesconfig - Update current config converting local mods to core'
590a5857 134 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
0748cb3e 135 @echo ' defconfig - New config with default from ARCH supplied defconfig'
7cf3d73b 136 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
e11f0496 137 @echo ' allnoconfig - New config where all options are answered with no'
0748cb3e
SR
138 @echo ' allyesconfig - New config where all options are accepted with yes'
139 @echo ' allmodconfig - New config selecting modules when possible'
140 @echo ' alldefconfig - New config with all symbols set to default'
141 @echo ' randconfig - New config with random answer to all options'
861b4ea4 142 @echo ' listnewconfig - List new options'
fb16d891 143 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their default value'
3aaefce1 144 @echo ' kvmconfig - Enable additional options for guest kernel support'
0da1d4a0 145 @echo ' tinyconfig - Configure the tiniest possible kernel'
1da177e4 146
2982de69
SR
147# lxdialog stuff
148check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
149
e9e40e14 150# Use recursively expanded variables so we do not call gcc unless
2982de69 151# we really need to do so. (Do not call gcc as part of make mrproper)
9ba95682
AL
152HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
153 -DLOCALE
2982de69 154
1da177e4
LT
155# ===========================================================================
156# Shared Makefile for the various kconfig executables:
157# conf: Used for defconfig, oldconfig and related targets
692d97c3 158# nconf: Used for the nconfig target.
159# Utilizes ncurses
6f26e5e4 160# mconf: Used for the menuconfig target
1da177e4
LT
161# Utilizes the lxdialog package
162# qconf: Used for the xconfig target
163# Based on QT which needs to be installed to compile it
164# gconf: Used for the gconfig target
165# Based on GTK which needs to be installed to compile it
166# object files used by all kconfig flavours
167
2982de69
SR
168lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
169lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
170
1da177e4 171conf-objs := conf.o zconf.tab.o
692d97c3 172mconf-objs := mconf.o zconf.tab.o $(lxdialog)
173nconf-objs := nconf.o zconf.tab.o nconf.gui.o
3b9fa093 174kxgettext-objs := kxgettext.o zconf.tab.o
f1943049 175qconf-cxxobjs := qconf.o
5a6f8d2b
AL
176qconf-objs := zconf.tab.o
177gconf-objs := gconf.o zconf.tab.o
1da177e4 178
022af62d 179hostprogs-y := conf nconf mconf kxgettext qconf gconf
1da177e4 180
5a6f8d2b 181clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
2f76b358 182clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
1020026f 183clean-files += config.pot linux.pot
1da177e4 184
6e588f6d
SR
185# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
186PHONY += $(obj)/dochecklxdialog
187$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
188$(obj)/dochecklxdialog:
7080e47b 189 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
6e588f6d
SR
190
191always := dochecklxdialog
192
aa1e5ef5
SR
193# Add environment specific flags
194HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
70a6a0cb 195
1da177e4 196# generated files seem to need this to find local include files
2f76b358 197HOSTCFLAGS_zconf.lex.o := -I$(src)
1da177e4
LT
198HOSTCFLAGS_zconf.tab.o := -I$(src)
199
378dbb2c
AL
200LEX_PREFIX_zconf := zconf
201YACC_PREFIX_zconf := zconf
202
5a6f8d2b
AL
203HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
204HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
1da177e4 205
5a6f8d2b 206HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
37193147 207HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
1ea3ad4e 208 -Wno-missing-prototypes
1da177e4 209
7080e47b
AL
210HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
211
544e7e54 212HOSTLOADLIBES_nconf = $(shell \
7285996a
BN
213 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
214 || pkg-config --libs menu panel ncurses 2>/dev/null \
544e7e54 215 || echo "-lmenu -lpanel -lncurses" )
1da177e4
LT
216$(obj)/qconf.o: $(obj)/.tmp_qtcheck
217
022af62d 218ifeq ($(MAKECMDGOALS),xconfig)
b3a5225f 219$(obj)/.tmp_qtcheck: $(src)/Makefile
1da177e4
LT
220-include $(obj)/.tmp_qtcheck
221
222# QT needs some extra effort...
223$(obj)/.tmp_qtcheck:
b3a5225f 224 @set -e; echo " CHECK qt"; dir=""; pkg=""; \
133c5f7c
AS
225 if ! pkg-config --exists QtCore 2> /dev/null; then \
226 echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
227 pkg-config --exists qt 2> /dev/null && pkg=qt; \
228 pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
229 if [ -n "$$pkg" ]; then \
230 cflags="\$$(shell pkg-config $$pkg --cflags)"; \
231 libs="\$$(shell pkg-config $$pkg --libs)"; \
232 moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
233 dir="$$(pkg-config $$pkg --variable=prefix)"; \
234 else \
235 for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
236 if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
237 done; \
238 if [ -z "$$dir" ]; then \
5b580fa6
MM
239 echo >&2 "*"; \
240 echo >&2 "* Unable to find any QT installation. Please make sure that"; \
241 echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
242 echo >&2 "* either qmake can be found or install pkg-config or set"; \
243 echo >&2 "* the QTDIR environment variable to the correct location."; \
244 echo >&2 "*"; \
133c5f7c
AS
245 false; \
246 fi; \
247 libpath=$$dir/lib; lib=qt; osdir=""; \
248 $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
249 osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
250 test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
251 test -f $$libpath/libqt-mt.so && lib=qt-mt; \
252 cflags="-I$$dir/include"; \
253 libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
254 moc="$$dir/bin/moc"; \
255 fi; \
256 if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
257 echo "*"; \
258 echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
259 echo "*"; \
260 moc="/usr/bin/moc"; \
261 fi; \
ab919c06 262 else \
458452f4
MM
263 cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
264 libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
48485949
YS
265 moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
266 [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
b3a5225f
RZ
267 fi; \
268 echo "KC_QT_CFLAGS=$$cflags" > $@; \
269 echo "KC_QT_LIBS=$$libs" >> $@; \
270 echo "KC_QT_MOC=$$moc" >> $@
1da177e4
LT
271endif
272
273$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
274
022af62d 275ifeq ($(MAKECMDGOALS),gconfig)
1da177e4
LT
276-include $(obj)/.tmp_gtkcheck
277
278# GTK needs some extra effort, too...
279$(obj)/.tmp_gtkcheck:
37193147
AB
280 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
281 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
1da177e4
LT
282 touch $@; \
283 else \
5b580fa6
MM
284 echo >&2 "*"; \
285 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
286 echo >&2 "*"; \
1da177e4
LT
287 false; \
288 fi \
289 else \
5b580fa6
MM
290 echo >&2 "*"; \
291 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
292 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
293 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
294 echo >&2 "*"; \
1da177e4
LT
295 false; \
296 fi
297endif
298
2f76b358 299$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
1da177e4 300
5a6f8d2b 301$(obj)/qconf.o: $(obj)/qconf.moc
1da177e4 302
ebca026a
YS
303quiet_cmd_moc = MOC $@
304 cmd_moc = $(KC_QT_MOC) -i $< -o $@
305
306$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
307 $(call cmd,moc)
1da177e4 308
46d26319
EG
309# Extract gconf menu items for I18N support
310$(obj)/gconf.glade.h: $(obj)/gconf.glade
2d80eb0f 311 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
a24a1b8e 312 $(obj)/gconf.glade
This page took 0.701362 seconds and 5 git commands to generate.